package org.artifactory.work.queue.mbean.git;

import org.artifactory.work.queue.mbean.WorkQueueMBean;

/**
 * Git repositories clone & update related job queue.
 *
 * @author Rotem Kfir
 */
public class GitWorkQueue implements GitWorkQueueMBean {

    private final WorkQueueMBean workQueueMBean;

    public GitWorkQueue(WorkQueueMBean workQueueMBean) {
        this.workQueueMBean = workQueueMBean;
    }

    @Override
    public int getQueueSize() {
        return workQueueMBean.getQueueSize();
    }

    @Override
    public int getNumberOfWorkers() {
        return workQueueMBean.getNumberOfWorkers();
    }

    @Override
    public int getMaxNumberOfWorkers() {
        return workQueueMBean.getMaxNumberOfWorkers();
    }

    @Override
    public String getName() {
        return workQueueMBean.getName();
    }
}
