package org.artifactory.maven.index;

import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;
import org.artifactory.descriptor.repo.RepoDescriptor;
import org.artifactory.repo.service.InternalRepositoryService;
import org.testng.Assert;
import org.testng.annotations.Test;

import java.util.List;
import java.util.Set;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

/**
 * @author Alexei Vainshtein
 */
public class MavenIndexerServiceImplTest {

    @Test
    public void testCalcSpecificReposForIndexing() {
        MavenIndexerServiceImpl indexerService = new MavenIndexerServiceImpl();
        InternalRepositoryService repositoryService = mock(InternalRepositoryService.class);
        indexerService.setRepositoryService(repositoryService);
        LocalRepoDescriptor local = new LocalRepoDescriptor();
        local.setKey("local");
        when(repositoryService.getLocalRepoDescriptors()).thenReturn(List.of(local));
        FederatedRepoDescriptor fed = new FederatedRepoDescriptor();
        fed.setKey("test");
        when(repositoryService.getFederatedRepoDescriptors()).thenReturn(List.of(fed));
        Set<? extends RepoDescriptor> repos = indexerService.calcSpecificReposForIndexing(List.of("test"));
        Assert.assertEquals(repos.size(), 1);
    }
}